; Ӳ 
KEY_PORT   EQU P1
SPEAKER    BIT P2.5
LEDS       EQU P2
RST        BIT P1.6
RS         BIT P1.7
RW         BIT P2.6
EN         BIT P2.7
DISPLAY_KEY BIT P1.5 

; 
PAUSE_FLAG  EQU 30H    ; ͣ־
SAVE_DPTR_H EQU 31H    ; DPTRֽ
SAVE_DPTR_L EQU 32H    ; DPTRֽ
SAVE_R5     EQU 33H    ; ļ
SAVE_R6     EQU 34H    ; Ƶʵֽ
SAVE_R7     EQU 35H    ; Ƶʸֽ
DISPLAY_MODE EQU 36H   ; ʾģʽ־
SONG        EQU 20H
READ        EQU 21H    ; ҪݵĴ洢Ԫ




ORG 0000H
    LJMP MAIN
ORG 000BH                ; ʱ0ж
    LJMP TIMER_ISR

ORG 0030H
MAIN:
    MOV SP, #60H         ; ջʼ
    MOV TMOD, #01H       ; ʱ0ģʽ1
    SETB EA              ; ж
    SETB ET0             ; ʱ0ж
    MOV KEY_PORT, #0FFH  ; ʼ˿
    MOV PAUSE_FLAG, #00H 
    MOV LEDS, #00H       
    MOV DISPLAY_MODE, #00H ; ʼʾģʽ
    CLR RST              ;оƬϵ縴λ
    LCALL DELAY_20MS
    SETB RST
    LCALL ST12864_INT    ; ʼҺ
    LCALL DISPLAY_WELCOME; ʾӭϢ

MAIN_LOOP:
    LCALL KEY_SCAN       
    JZ MAIN_LOOP         

    ; Ƿʾл(P1.5)
    MOV B, A             
    ANL A, #20H          ; P1.5
    JZ CHECK_PLAY_KEYS   ; P1.5鲥ż
    
    ; ʾл
    INC DISPLAY_MODE     ; лʾģʽ
    MOV A, DISPLAY_MODE
    CJNE A, #05H, DISPLAY_MODE_OK
    MOV DISPLAY_MODE, #00H ; ѭʾģʽ
 
;ʾӭϢ  
DISPLAY_MODE_OK:           
    MOV A, DISPLAY_MODE
    CJNE A, #00H, MODE1
    LCALL CLEAR_SCREEN    ; 
    LCALL DISPLAY_WELCOME
    LJMP MAIN_LOOP

;ʾ
MODE1:
    CJNE A, #01H, MODE2
    LCALL CLEAR_SCREEN   
    LCALL DISPLAY_DOREMI
    LJMP MAIN_LOOP

;ʾ
MODE2:
    CJNE A, #02H, MODE3
    LCALL CLEAR_SCREEN    
    LCALL DISPLAY_JASMINE
    LJMP MAIN_LOOP

;ʾ֮
MODE3:
    CJNE A, #03H, MODE4
    LCALL CLEAR_SCREEN    
    LCALL DISPLAY_SKYCASTLE
    LJMP MAIN_LOOP

;ʾֻϻ
MODE4:
    LCALL CLEAR_SCREEN    
    LCALL DISPLAY_TIGER
    LJMP MAIN_LOOP

CHECK_PLAY_KEYS:
    MOV A, B
    ANL A, #1FH          ; P1.0-P1.4
    JZ MAIN_LOOP         
    
    ; LEDʾ
    MOV R0, A
    MOV A, LEDS
    ANL A, #0F0H
    ORL A, R0
    MOV LEDS, A

    
    MOV A, B
    ANL A, #04H
    JZ NOT_THIRD_KEY
    SETB LEDS.2
    SJMP CHECK_SONG
NOT_THIRD_KEY:
    CLR LEDS.2

;
CHECK_SONG:
    MOV A, B
    CJNE A, #01H, CHK_SONG2
    MOV DPTR, #FREQ1_DATA
    SJMP START_PLAY

;
CHK_SONG2:
    CJNE A, #02H, CHK_SONG3
    MOV DPTR, #FREQ2_DATA
    SJMP START_PLAY

;֮
CHK_SONG3:
    CJNE A, #04H, CHK_SONG4
    MOV DPTR, #FREQ3_DATA
    SJMP START_PLAY

;ֻϻ
CHK_SONG4:
    CJNE A, #08H, CHK_STOP
    MOV DPTR, #FREQ4_DATA  
    SJMP START_PLAY

;ͣ
CHK_STOP:
    CJNE A, #10H, NOT_EQUAL
    SJMP EQUAL

NOT_EQUAL:
    LJMP MAIN_LOOP

EQUAL:
    JB PAUSE_FLAG, UNPAUSE   
    JNB TR0, LONG_MAIN_LOOP  
    CLR TR0
    CLR SPEAKER
    MOV SAVE_DPTR_H, DPH
    MOV SAVE_DPTR_L, DPL
    MOV SAVE_R5, R5       
    MOV SAVE_R6, R6
    MOV SAVE_R7, R7
    MOV PAUSE_FLAG, #01H
    CLR LEDS.0
    CLR LEDS.1
    CLR LEDS.2
    CLR LEDS.3
    SETB LEDS.4
    LJMP MAIN_LOOP  

LONG_MAIN_LOOP:
    LJMP MAIN_LOOP  

;ָ
UNPAUSE:
    MOV DPH, SAVE_DPTR_H
    MOV DPL, SAVE_DPTR_L
    MOV R5, SAVE_R5
    MOV R6, SAVE_R6
    MOV R7, SAVE_R7
    MOV TH0, R7
    MOV TL0, R6
    SETB TR0
    MOV PAUSE_FLAG, #00H
    CLR LEDS.4
    LJMP PLAY_LOOP 

START_PLAY:
    CLR TR0              
    CLR SPEAKER
    SETB ET0             
    CLR A                
    MOV PAUSE_FLAG, #00H 
    CLR LEDS.4           

PLAY_LOOP:
    PUSH DPL             
    PUSH DPH

;ȡƵʺͽĲ
PLAY_NEXT_NOTE:
    CLR A
    MOVC A, @A+DPTR      
    MOV R7, A
    INC DPTR
    CLR A
    MOVC A, @A+DPTR      
    MOV R6, A
    INC DPTR
    MOV A, R7
    ORL A, R6
    JZ CHECK_LOOP
    CLR A
    MOVC A, @A+DPTR
    MOV R5, A
    INC DPTR
    MOV TH0, R7
    MOV TL0, R6
    SETB TR0

PLAY_DELAY:
    MOV R4, #5           
DELAY_LOOP:
    LCALL DELAY_50MS
    LCALL KEY_CHECK
    JNZ HANDLE_KEY
    DJNZ R4, DELAY_LOOP
    DJNZ R5, PLAY_DELAY
    LJMP PLAY_NEXT_NOTE

;Ƿͣ
HANDLE_KEY:
    CJNE A, #10H, STOP_PLAY  
    CLR TR0
    CLR SPEAKER
    MOV SAVE_DPTR_H, DPH
    MOV SAVE_DPTR_L, DPL
    MOV SAVE_R5, R5       
    MOV SAVE_R6, R6
    MOV SAVE_R7, R7
    MOV PAUSE_FLAG, #01H
    CLR LEDS.0
    CLR LEDS.1
    CLR LEDS.2
    CLR LEDS.3
    SETB LEDS.4
    MOV SP, #60H
    LJMP MAIN_LOOP

CHECK_LOOP:
    POP DPH              
    POP DPL
    LCALL KEY_CHECK
    JNZ CHECK_KEY        
    LJMP PLAY_NEXT_NOTE  
    
CHECK_KEY:               
    LJMP MAIN_LOOP       

STOP_PLAY:
    POP DPH              
    POP DPL
    CLR TR0
    CLR SPEAKER
    MOV PAUSE_FLAG, #00H
    CLR LEDS.4           
    LJMP MAIN_LOOP

;ʱжϷ 
TIMER_ISR:
    CPL SPEAKER          
    MOV TH0, R7          
    MOV TL0, R6
    RETI

;12864ʾ
ST12864_INT:            ; ʼ
    MOV SONG,#30H   
    LCALL SEND_ML
    MOV SONG,#01H   
    LCALL SEND_ML     
    MOV SONG,#06H   
    LCALL SEND_ML
    MOV SONG,#0CH   
    LCALL SEND_ML
    RET

DISPLAY_WELCOME:        ; ӭϢ
    MOV SONG,#80H      
    LCALL SEND_ML
    MOV DPTR,#WELCOME_MSG
    LCALL WRITE_STRING
    MOV SONG,#90H      
    LCALL SEND_ML
    MOV DPTR,#WELCOME_MSG2
    LCALL WRITE_STRING
    RET

DISPLAY_DOREMI:         ; ʾ
    MOV SONG,#80H      
    LCALL SEND_ML
    MOV DPTR,#DOREMI_MSG
    LCALL WRITE_STRING
    MOV SONG,#90H      
    LCALL SEND_ML
    MOV DPTR,#BLANK_MSG
    LCALL WRITE_STRING
    RET

DISPLAY_JASMINE:        ; ʾ
    MOV SONG,#80H      
    LCALL SEND_ML
    MOV DPTR,#JASMINE_MSG
    LCALL WRITE_STRING
    MOV SONG,#90H      
    LCALL SEND_ML
    MOV DPTR,#BLANK_MSG
    LCALL WRITE_STRING
    RET

DISPLAY_SKYCASTLE:      ; ʾ֮
    MOV SONG,#80H      
    LCALL SEND_ML
    MOV DPTR,#SKYCASTLE_MSG
    LCALL WRITE_STRING
    MOV SONG,#90H      
    LCALL SEND_ML
    MOV DPTR,#BLANK_MSG
    LCALL WRITE_STRING
    RET

DISPLAY_TIGER:          ; ʾֻϻ
    MOV SONG,#80H      
    LCALL SEND_ML
    MOV DPTR,#TIGER_MSG
    LCALL WRITE_STRING
    MOV SONG,#90H      
    LCALL SEND_ML
    MOV DPTR,#BLANK_MSG
    LCALL WRITE_STRING
    RET

WRITE_STRING:           ; д
    CLR A
WRITE_LOOP:
    MOVC A,@A+DPTR
    JZ WRITE_END
    MOV SONG,A
    LCALL SEND_SJ
    INC DPTR
    CLR A
    SJMP WRITE_LOOP
WRITE_END:
    RET

SEND_ML:                ; 
    LCALL CHK_BUSY    
    MOV P0,SONG     
    CLR RS
    CLR RW          
    SETB EN
    LCALL DELAY_20MS
    CLR EN
    RET

SEND_SJ:                ; 
    LCALL CHK_BUSY
    MOV P0,SONG
    SETB RS
    CLR RW
    SETB EN
    LCALL DELAY_20MS
    CLR EN
    RET

CHK_BUSY:               ; æ״̬
    MOV P0,#0FFH    
    CLR RS
    SETB RW
    SETB EN         
CHK_LOOP:
    MOV A,P0
    JB P0.7,CHK_LOOP   
    CLR EN
    RET

CLEAR_SCREEN:           ; ӳ
    MOV SONG, #01H      ; 
    LCALL SEND_ML
    LCALL DELAY_20MS    ; ʵʱȴ
    RET

;  
WELCOME_MSG:
    DB  "ֲ",0
WELCOME_MSG2:
    DB  "° 1-6",0
DOREMI_MSG:
    DB  "䷢",0
JASMINE_MSG:
    DB  "",0
SKYCASTLE_MSG:
    DB  "֮Ǵ",0
TIGER_MSG:
    DB  "ֻϻ",0
BLANK_MSG:
    DB  "",0

; ɨ 
KEY_SCAN:
    MOV A, KEY_PORT
    CPL A                ; ȡΪ1
    ANL A, #3FH          ; ȡP1.0 - P1.5(6)
    JZ KEY_RET           ; ް
    MOV R0, A            ; ݴֵ
    LCALL DELAY_20MS     ; 
    MOV A, KEY_PORT
    CPL A
    ANL A, #3FH
    MOV 37H, R0          ; R0ֵ͵ֱѰַԪ37H
    CJNE A, 37H, KEY_RET ; ȽA37Hֵ
WAIT_RELEASE:
    MOV A, KEY_PORT
    CPL A
    ANL A, #3FH
    JNZ WAIT_RELEASE
    MOV A, R0            ; ؼֵ
    RET
KEY_RET:
    CLR A
    RET


KEY_CHECK:
    MOV A, KEY_PORT
    CPL A
    ANL A, #3FH          
    RET

; ʱӳ
DELAY_20MS:             ; 20ms@12MHz
    MOV R2, #40
DL20_1: 
   MOV R1, #250
DL20_2: 
    DJNZ R1, DL20_2
    DJNZ R2, DL20_1
    RET

DELAY_50MS:             ; 50ms@12MHz
    MOV R2, #100
DL50_1: 
    MOV R1, #250
DL50_2: 
    DJNZ R1, DL50_2
    DJNZ R2, DL50_1
    RET   


;  
; Ƶʼ㹫ʽֵ = 65536 - 12000000/(12*(2*Ƶ))
FREQ1_DATA:  
    DW 0F820H    ; 248Hz
    DB 4
    DW 0F8F9H    ; 278Hz
    DB 4
    DW 0F9BDH    ; 312Hz
    DB 4
    DW 0FA15H    ; 330Hz
    DB 4
    DW 0FABCH    ; 371Hz
    DB 4
    DW 0FB4EH    ; 416Hz
    DB 4
    DW 0FBD1H    ; 467Hz
    DB 4
    DW 0000H     ; ־
    DB 0

FREQ2_DATA:  ; 
    DW 0FB4EH    ; 416Hz
    DB 4
    DW 0FB4EH    ; 416Hz
    DB 2
    DW 0FC0DH    ; 495Hz
    DB 2
    DW 0FC7CH    ; 556Hz
    DB 2
    DW 0F429H    ; 165Hz
    DB 2
    DW 0FD0BH    ; 661Hz
    DB 2
    DW 0FC7CH    ; 556Hz
    DB 2
    DW 0FC0DH    ; 495Hz
    DB 4
    DW 0FC0DH    ; 495Hz
    DB 2
    DW 0FC7CH    ; 556Hz
    DB 2
    DW 0FC0DH    ; 495Hz
    DB 8
    DW 0000H     ; ־
    DB 0

FREQ3_DATA:  ; ֮
    DW 0FC0DH    ; 495Hz
    DB 4
    DW 0FC7CH    ; 556Hz
    DB 4
    DW 0FCAFH    ; 589Hz
    DB 4
    DW 0FC7CH    ; 556Hz
    DB 2
    DW 0FCAFH    ; 589Hz
    DB 2
    DW 0FD5EH    ; 742Hz
    DB 2
    DW 0FC7CH    ; 556Hz
    DB 6
    DW 0FABCH    ; 371Hz
    DB 2
    DW 0FABCH    ; 371Hz
    DB 4
    DW 0FC0DH    ; 495Hz
    DB 12
    DW 0FB92H    ; 441Hz
    DB 2
    DW 0FC0DH    ; 495Hz
    DB 2
    DW 0FCAFH    ; 589Hz
    DB 4
    DW 0FB92H    ; 441Hz
    DB 12
    DW 0FABCH    ; 371Hz
    DB 4
    DW 0FB07H    ; 393Hz
    DB 6
    DW 0FABCH    ; 371Hz
    DB 2
    DW 0FB07H    ; 393Hz
    DB 4
    DW 0FCAFH    ; 589Hz
    DB 4
    DW 0FABCH    ; 371Hz
    DB 8
    DW 0FCAFH    ; 589Hz
    DB 2
    DW 0FCAFH    ; 589Hz
    DB 2
    DW 0FCAFH    ; 589Hz
    DB 2
    DW 0FCAFH    ; 589Hz
    DB 2
    DW 0FC7CH    ; 556Hz
    DB 6
    DW 0FB07H    ; 393Hz
    DB 2
    DW 0FB07H    ; 393Hz
    DB 4
    DW 0FC7CH    ; 556Hz
    DB 4
    DW 0FC7CH    ; 556Hz
    DB 8
    DW 0FC0DH    ; 495Hz
    DB 4
    DW 0FC7CH    ; 556Hz
    DB 2
    DW 0FCAFH    ; 589Hz
    DB 4
    DW 0FC7CH    ; 556Hz
    DB 2
    DW 0FCAFH    ; 589Hz
    DB 2
    DW 0FD5EH    ; 742Hz
    DB 2
    DW 0FC7CH    ; 556Hz
    DB 12
    DW 0FABCH    ; 371Hz
    DB 2
    DW 0FABCH    ; 371Hz
    DB 2
    DW 0FC0DH    ; 495Hz
    DB 6
    DW 0FB92H    ; 441Hz
    DB 2
    DW 0FC0DH    ; 495Hz
    DB 4
    DW 0FCAFH    ; 589Hz
    DB 4
    DW 0FB92H    ; 441Hz
    DB 12
    DW 0FA15H    ; 330Hz
    DB 2
    DW 0FABCH    ; 371Hz
    DB 2
    DW 0FB07H    ; 393Hz
    DB 4
    DW 0FCAFH    ; 589Hz
    DB 2
    DW 0FC7CH    ; 556Hz
    DB 4
    DW 0FCAFH    ; 589Hz
    DB 6
    DW 0FD0BH    ; 661Hz
    DB 2
    DW 0FD0BH    ; 661Hz
    DB 2
    DW 0FD5EH    ; 742Hz
    DB 2
    DW 0FCAFH    ; 589Hz
    DB 10
    DW 0FCAFH    ; 589Hz
    DB 2
    DW 0FC7CH    ; 556Hz
    DB 2
    DW 0FC0DH    ; 495Hz
    DB 2
    DW 0FC0DH    ; 495Hz
    DB 2
    DW 0FC7CH    ; 556Hz
    DB 4
    DW 0FB92H    ; 441Hz
    DB 4
    DW 0FC0DH    ; 495Hz
    DB 12
    DW 0FCAFH    ; 589Hz
    DB 2
    DW 0FD0BH    ; 661Hz
    DB 2
    DW 0FD5EH    ; 742Hz
    DB 6
    DW 0FD0BH    ; 661Hz
    DB 2
    DW 0FD5EH    ; 742Hz
    DB 2
    DW 0FDC9H    ; 882Hz
    DB 2
    DW 0FD0BH    ; 661Hz
    DB 12
    DW 0FB92H    ; 441Hz
    DB 2
    DW 0FB92H    ; 441Hz
    DB 2
    DW 0FCAFH    ; 589Hz
    DB 6
    DW 0FC7CH    ; 556Hz
    DB 2
    DW 0FCAFH    ; 589Hz
    DB 2
    DW 0FD5EH    ; 742Hz
    DB 2
    DW 0FD5EH    ; 742Hz
    DB 16
    DW 0FC0DH    ; 495Hz
    DB 2
    DW 0FC7CH    ; 556Hz
    DB 2
    DW 0FCAFH    ; 589Hz
    DB 4
    DW 0FC7CH    ; 556Hz
    DB 4
    DW 0FD0BH    ; 661Hz
    DB 2
    DW 0FD0BH    ; 661Hz
    DB 2
    DW 0FCAFH    ; 589Hz
    DB 6
    DW 0FB92H    ; 441Hz
    DB 10
    DW 0FD83H    ; 786Hz
    DB 4
    DW 0FD5EH    ; 742Hz
    DB 4
    DW 0FD0BH    ; 661Hz
    DB 4
    DW 0FCAFH    ; 589Hz
    DB 4
    DW 0FD5EH    ; 742Hz
    DB 12
    DW 0FD5EH    ; 742Hz
    DB 4
    DW 0FE06H    ; 990Hz
    DB 8
    DW 0FDC9H    ; 882Hz
    DB 4
    DW 0FDC9H    ; 882Hz
    DB 4
    DW 0FD5EH    ; 742Hz
    DB 2
    DW 0FD0BH    ; 661Hz
    DB 2
    DW 0FCAFH    ; 589Hz
    DB 8
    DW 0FCAFH    ; 589Hz
    DB 2
    DW 0FD0BH    ; 661Hz
    DB 2
    DW 0FCAFH    ; 589Hz
    DB 2
    DW 0FC7CH    ; 556Hz
    DB 4
    DW 0FC0DH    ; 495Hz
    DB 4
    DW 0FC0DH    ; 495Hz
    DB 4
    DW 0FC7CH    ; 556Hz
    DB 2
    DW 0000H     ; ־
    DB 0

FREQ4_DATA:  ; ֻϻ
    
    DW 0F884H    ; 261Hz
    DB 4
    DW 0F955H    ; 293Hz
    DB 4
    DW 0FA10H    ; 329Hz
    DB 4
    DW 0F884H    ; 261Hz
    DB 4
    
    DW 0F884H    ; 261Hz
    DB 4
    DW 0F955H    ; 293Hz
    DB 4
    DW 0FA10H    ; 329Hz
    DB 4
    DW 0F884H    ; 261Hz
    DB 4
    
    DW 0FA10H    ; 329Hz
    DB 4
    DW 0FA67H    ; 349Hz
    DB 4
    DW 0FB07H    ; 393Hz
    DB 8
    
    DW 0FA10H    ; 329Hz
    DB 4
    DW 0FA67H    ; 349Hz
    DB 4
    DW 0FB07H    ; 393Hz
    DB 8
   
    DW 0FB07H    ; 393Hz
    DB 2
    DW 0FB92H    ; 441Hz
    DB 2
    DW 0FA05H    ; 393Hz
    DB 2
    DW 0FA67H    ; 349Hz
    DB 2
    DW 0FA10H    ; 329Hz
    DB 4
    DW 0F884H    ; 261Hz
    DB 4
   
    DW 0FA05H    ; 393Hz
    DB 2
    DW 0FACCH    ; 441Hz
    DB 2
    DW 0FA05H     ; 393Hz
    DB 2
    DW 0FA67H     ; 349Hz
    DB 2
    DW 0FA10H      ; 329Hz
    DB 4
    DW 0F884H     ; 261Hz
    DB 4
    ; 
    DW 0000H     ; ־
    DB 0

END 
